'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _babylon = require('babylon');

var _sourceMap = require('babel-generator/lib/source-map');

var _sourceMap2 = _interopRequireDefault(_sourceMap);

var _jsy_printer = require('./jsy_printer');

var _jsy_printer2 = _interopRequireDefault(_jsy_printer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class JSYGenerator extends _jsy_printer2.default {
  constructor(ast, opts = {}, code) {
    if (opts.sourceMaps || undefined == opts.sourceMaps) {
      var srcmap = new _sourceMap2.default(opts, code);
    }

    const format = opts.jsy_format || jsy_format;
    super(format, srcmap || null, ast.tokens);
    Object.defineProperties(this, {
      ast: { value: ast } });
  }

  generate() {
    return super.generate(this.ast);
  }

  static generate(code, opts) {
    const ast = (0, _babylon.parse)(code, {
      allowReturnOutsideFunction: true });

    const gen = new JSYGenerator(ast, opts, code);
    return gen.generate();
  }
}exports.default = JSYGenerator;


const jsy_format = {
  compact: false, minified: false,
  comments: true, shouldPrintComment: () => true,
  indent: { base: 0, style: '  ',
    adjustMultilineComment: true },

  quotes: "'",
  jsonCompatibleStrings: false,
  concise: false,
  retainLines: false,
  retainFunctionParens: false };

JSYGenerator.jsy_format = jsy_format;